@echo off
echo Extract MOD16 ET global monthly coverage in mm per month
echo Data is experimental 
echo File name format MOD16A2.A2000001.h00v08.105.2013121200130.hdf
echo.
echo. 
echo Data is extracted from ftp://ftp.ntsg.umt.edu/pub/MODIS/NTSG_Products/MOD16/MOD16A2.105_MERRAGMAO/Y2000/D001/
echo Data is in tiles of 10 by 10 degree
echo Data is in HDF-4 format
echo Filename input convention MOD16A2.A%shortfilename1%%shortfilename2%.h%Hori%v%Verti%.105.2013121200130.hdf
echo Select the upper left X coordinate in degree from 180 to 170
echo Select the upper left Y coordinate in degree from 90 to -80
echo.
echo.
echo Import routine assumes 10 by 10 degree tiles
echo Use of julian day with 8 day intervals
echo starting day of year is 001
echo followed by 009, 017, etc




set longfilename=%1
set shortfilename1=%longfilename:~0,4%
set shortfilename2=%longfilename:~4,3%
set InputDrive=%2
set InputDir=%3
set OutputDrive=%4
set OutputDir=%5
set gdalDir=%6
set IlwDir=%7
set UtilDir=%8

cd\
%OutputDrive%
cd %OutputDir%

echo your current working directory = %OutputDrive%\%OutputDir%


cd /d "%ilwDir%\Extensions\ISOD-Toolbox\toolbox_startscript\Mod16"

cmd /c powershell -ExecutionPolicy RemoteSigned -File .\mod16_ET_startbox2.ps1"

cd /d "%OutputDrive%\%OutputDir%"
 
if exist "%ilwDir%\Extensions\ISOD-Toolbox\toolbox_startscript\Mod16\st_ETno.txt" GOTO MESSAGE

GOTO START

:MESSAGE
echo.
echo.

echo The input file parameters are not properly specified.
echo.
echo Check your Date stamp settings
echo Your current Date stamp used is %shortfilename1%%shortfilename2%
echo.
echo Also check your Longitude and Latitude settings for your tile of interest
echo Your current Long - Lat used is %Hori% - %Verti%


pause

del "%ilwDir%\Extensions\ISOD-Toolbox\toolbox_startscript\Mod16\st_ETno.txt"

GOTO END

:START

set Hori=
set Verti=


call "%ilwDir%\Extensions\ISOD-Toolbox\toolbox_startscript\Mod16\st_ET.bat"


set /A Horizontal=(360-180+%Hori%)/10
rem echo Horizontal=%Horizontal%

set /A Vertical=(180-90-%Verti%)/10
rem echo Vertical=%Vertical%

if %Horizontal% LEQ 9 (
set Horizontal=0%Horizontal%
)


if %Vertical% LEQ 9 (
set Vertical=0%Vertical%
)


del "%ilwDir%\Extensions\ISOD-Toolbox\toolbox_startscript\Mod16\st_ET.bat"

echo.
echo.

echo MODIS-ET Upper Left Tile Easting given = %Hori%
echo MODIS-ET Upper Left Tile Northing given = %Verti%
echo Your MODIS-ET tile eastings Horizontal Index Number = %Horizontal%
echo Your MODIS-ET tile northings Vertical Index Number = %Vertical%
echo.
echo Your current MOD16-ET Tile specification = MOD16A2.A%shortfilename1%M%shortfilename2%.h%Horizontal%v%Vertical%.105.productiondate.hdf
echo.
echo Your current working directory = %OutputDrive%\%OutputDir%
echo.
echo.


"%UtilDir%\wget\wget" ftp://ftp.ntsg.umt.edu/pub/MODIS/NTSG_Products/MOD16/MOD16A2.105_MERRAGMAO/Y%shortfilename1%/D%shortfilename2%/MOD16A2.A%shortfilename1%%shortfilename2%.h%Horizontal%v%Vertical%.105.*.hdf

ren "MOD16A2.A%shortfilename1%%shortfilename2%.h%Horizontal%v%Vertical%.105.*.hdf" MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%.hdf



echo off
echo.
echo.
if not exist "%OutputDrive%\%OutputDir%\MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%.hdf"  goto MESSAGE1
echo The file "MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%.hdf" has been retrieved and transferred to your current working directory
echo.
echo.


GOTO START1

:MESSAGE1
echo The input file was not found in the archive.
echo Check your Date stamp settings
echo Your current Date stamp used is %shortfilename1%%shortfilename2%
echo Also check your Longitude and Latitude settings for your tile of interest
echo Your current Long - Lat used is %Hori% - %Verti%
echo Data is retrieved from ftp://ftp.ntsg.umt.edu/pub/MODIS/NTSG_Products/MOD16/MOD16A2_MONTHLY.MERRA_GMAO_1kmALB/
echo Check also manually if the data exists on ftp archive (see link above)
echo Internet has a transient nature - addresses might not be valid or has changed after some time!


pause

GOTO END

:START1


"%GdalDir%\gdal_translate.exe" -of ILWIS HDF4_EOS:EOS_GRID:"MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%.hdf":MOD_Grid_MOD16A2:ET_1km MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%_ET_1kmt.mpr
"%GdalDir%\gdal_translate.exe" -of ILWIS HDF4_EOS:EOS_GRID:"MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%.hdf":MOD_Grid_MOD16A2:PET_1km MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%_PET_1kmt.mpr


"%IlwDir%\ilwis.exe" -C %OutputDrive%\%OutputDir%\MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%_ET_1km.mpr{dom=value;vr=-327.6700:327.0000:0.0001}:=%OutputDrive%\%OutputDir%\MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%_ET_1kmt.mpr*0.1
"%IlwDir%\ilwis.exe" -C %OutputDrive%\%OutputDir%\MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%_PET_1km.mpr{dom=value;vr=-327.6700:327.0000:0.0001}:=%OutputDrive%\%OutputDir%\MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%_PET_1kmt.mpr*0.1


del %OutputDrive%\%OutputDir%\MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%_ET_1kmt.mp*
del %OutputDrive%\%OutputDir%\MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%_PET_1kmt.mp*

del %OutputDrive%\%OutputDir%\MOD16A2_A%shortfilename1%%shortfilename2%_h%Horizontal%v%Vertical%.hdf


:END
"%IlwDir%\ilwis.exe" -C closeall