@echo off
echo Import Aggregated daily RFS
echo Produced by INPE
echo Sum 96 MPE events
echo Retrieved from ftp://ftp.itc.nl/pub/mpe/inpe_rfs/
echo original ILWIS files not deleted
echo.
echo.

set longfilename=%1
set shortfilename1=%longfilename:~0,12%
set InputDrive=%2
set InputDir=%3
set OutputDrive=%4
set OutputDir=%5
set gdalDir=%6
set IlwDir=%7
set UtilDir=%8
set irfanviewdir=%9

cd\
%OutputDrive%
cd %OutputDir%

echo your current working directory = %OutputDrive%\%OutputDir%
echo.
echo.


"%UtilDir%\wget\wget" ftp://ftp.itc.nl/pub/mpe/inpe_rfs/sumrfs_%shortfilename1%.zip


if not exist "%OutputDrive%\%OutputDir%\sumrfs_%shortfilename1%.zip"  goto MESSAGE

GOTO START

:MESSAGE
echo The input file was not found in the archive.
echo Check your Date stamp settings
echo Your current Date stamp used is %shortfilename1%
echo Data is retrieved from ftp://ftp.itc.nl/pub/mpe/inpe_rfs
echo Check also manually if the data exists on ftp archive (see link above)
echo Internet has a transient nature - addresses might not be valid or has changed after some time

pause

GOTO END

:START
echo.
echo.
echo Retrieved rainfall data is resampled and exported to a PNG for display in Google Earth
echo After inspecting the rainfall in Google Earth close Google Earth to continue
echo.
echo. 

echo off
"%UtilDir%\7z" e sumrfs_%shortfilename1%.zip fsumrfs%shortfilename1%.mp* 

"%IlwDir%\ilwis.exe" -C setgrf %OutputDrive%\%OutputDir%\fsumrfs%shortfilename1%.mpr %OutputDrive%\%OutputDir%\hidro_30m.grf 

copy %UtilDir%\rfsgoogle.*

"%IlwDir%\ilwis.exe" -C  rfs%shortfilename1%_latlon:=MapResample(%OutputDrive%\%OutputDir%\fsumrfs%shortfilename1%,rfsgoogle.grf,bicubic)


"%IlwDir%\ilwis.exe" -C rfs%shortfilename1%_latlon_red:=min(255,max(0,iff(rfs%shortfilename1%_latlon.mpr le 2,0+(64-0)*(rfs%shortfilename1%_latlon.mpr-0)/(2-0),iff(rfs%shortfilename1%_latlon.mpr le 5,64+(24-64)*(rfs%shortfilename1%_latlon.mpr-2)/(5-2),iff(rfs%shortfilename1%_latlon.mpr le 12,24+(255-24)*(rfs%shortfilename1%_latlon.mpr-5)/(12-5),iff(rfs%shortfilename1%_latlon.mpr le 20,255+(255-255)*(rfs%shortfilename1%_latlon.mpr-12)/(20-12), iff(rfs%shortfilename1%_latlon.mpr le 200,255+(255-255)*(rfs%shortfilename1%_latlon.mpr-20)/(200-20),150)))))))

"%IlwDir%\ilwis.exe" -C rfs%shortfilename1%_latlon_green:=min(255,max(0,iff(rfs%shortfilename1%_latlon.mpr le 2,0+(104-0)*(rfs%shortfilename1%_latlon.mpr-0)/(2-0),iff(rfs%shortfilename1%_latlon.mpr le 5,104+(204-104)*(rfs%shortfilename1%_latlon.mpr-2)/(5-2),iff(rfs%shortfilename1%_latlon.mpr le 12,204+(255-204)*(rfs%shortfilename1%_latlon.mpr-5)/(12-5),iff(rfs%shortfilename1%_latlon.mpr le 20,255+(136-255)*(rfs%shortfilename1%_latlon.mpr-12)/(20-12), iff(rfs%shortfilename1%_latlon.mpr le 200,136+(0-136)*(rfs%shortfilename1%_latlon.mpr-20)/(200-20),0)))))))

"%IlwDir%\ilwis.exe" -C rfs%shortfilename1%_latlon_blue:=min(255,max(0,iff(rfs%shortfilename1%_latlon.mpr le 2,255+(225-255)*(rfs%shortfilename1%_latlon.mpr-0)/(2-0),iff(rfs%shortfilename1%_latlon.mpr le 5,225+(224-225)*(rfs%shortfilename1%_latlon.mpr-2)/(5-2),iff(rfs%shortfilename1%_latlon.mpr le 12,224+(0-224)*(rfs%shortfilename1%_latlon.mpr-5)/(12-5),iff(rfs%shortfilename1%_latlon.mpr le 20,0+(0-0)*(rfs%shortfilename1%_latlon.mpr-12)/(20-12),iff(rfs%shortfilename1%_latlon.mpr le 200,0+(0-0)*(rfs%shortfilename1%_latlon.mpr-20)/(200-20),0)))))))

"%IlwDir%\ilwis.exe" -C rfs%shortfilename1%_latlon_alpha:=ifundef(rfs%shortfilename1%_latlon.mpr,0,255)


rem Create a MapList with the bands properly ordered so that it can be exported to PNG

"%IlwDir%\ilwis.exe" -C crmaplist rfs%shortfilename1%_latlon.mpl rfs%shortfilename1%_latlon_red.mpr rfs%shortfilename1%_latlon_green.mpr rfs%shortfilename1%_latlon_blue.mpr rfs%shortfilename1%_latlon_alpha.mpr



rem export to PNG

PATH=%IlwDir%\Extensions\ISOD-Toolbox\GDAL\bin
set GEOTIFF_CSV=%IlwDir%\Extensions\ISOD-Toolbox\GDAL\gdal_data
set GDAL_DATA=%IlwDir%\Extensions\ISOD-Toolbox\GDAL\gdal_data

"%gdalDir%\gdal_translate" -of PNG -ot Byte rfs%shortfilename1%_latlon.mpl rfs%shortfilename1%_latlon.png

rem generate KML file
echo ^<?xml version="1.0" encoding="UTF-8"?^> > rfs%shortfilename1%_latlon.kml
echo ^<kml xmlns="http://www.opengis.net/kml/2.2" xmlns:gx="http://www.google.com/kml/ext/2.2"^> >> rfs%shortfilename1%_latlon.kml
echo ^<Document^> >> rfs%shortfilename1%_latlon.kml

echo   ^<name^>rfs%shortfilename1%^</name^> >> rfs%shortfilename1%_latlon.kml
echo   ^<description^>Google raster overlay of image rfs%shortfilename1%.mpr^</description^> >> rfs%shortfilename1%_latlon.kml
echo   ^<GroundOverlay^> >> rfs%shortfilename1%_latlon.kml
echo     ^<name^>Raster data^</name^> >> rfs%shortfilename1%_latlon.kml
echo     ^<LatLonBox^> >> rfs%shortfilename1%_latlon.kml
echo       ^<north^>15^</north^> >> rfs%shortfilename1%_latlon.kml
echo       ^<south^>-45^</south^> >> rfs%shortfilename1%_latlon.kml
echo       ^<east^>-30^</east^> >> rfs%shortfilename1%_latlon.kml
echo       ^<west^>-82^</west^> >> rfs%shortfilename1%_latlon.kml
echo     ^</LatLonBox^> >> rfs%shortfilename1%_latlon.kml
echo     ^<Icon^> >> rfs%shortfilename1%_latlon.kml
echo       ^<href^>rfs%shortfilename1%_latlon.png^</href^> >> rfs%shortfilename1%_latlon.kml
echo     ^</Icon^> >> rfs%shortfilename1%_latlon.kml
echo   ^</GroundOverlay^> >> rfs%shortfilename1%_latlon.kml

echo ^<ScreenOverlay^> >> rfs%shortfilename1%_latlon.kml
echo ^<name^>RFS Legend in mm/day^</name^> >> rfs%shortfilename1%_latlon.kml
echo ^<Icon^> ^<href^>%IlwDir%\Extensions\ISOD-Toolbox\util\leg_mpe2.png^</href^> >> rfs%shortfilename1%_latlon.kml
echo ^</Icon^> >> rfs%shortfilename1%_latlon.kml >> rfs%shortfilename1%_latlon.kml
echo ^<overlayXY x="0" y="0" xunits="fraction" yunits="fraction"/^> >> rfs%shortfilename1%_latlon.kml 
echo ^<screenXY x="25" y="95" xunits="pixels" yunits="pixels"/^> >> rfs%shortfilename1%_latlon.kml 
echo ^<rotationXY x="0.5" y="0.5" xunits="fraction" yunits="fraction"/^> >> rfs%shortfilename1%_latlon.kml 
echo ^<size x="0" y="0" xunits="pixels" yunits="pixels"/^> >> rfs%shortfilename1%_latlon.kml
echo ^</ScreenOverlay^> >> rfs%shortfilename1%_latlon.kml >> rfs%shortfilename1%_latlon.kml

echo ^<Placemark id="RFS"^> >> rfs%shortfilename1%_latlon.kml
echo ^<name^>Aggregated RFS Map (mm/day) for %shortfilename1% ^</name^> >> rfs%shortfilename1%_latlon.kml
echo ^<Snippet^>Aggregation period from 00:00 - 23:45 UTC ^</Snippet^> >> rfs%shortfilename1%_latlon.kml
echo ^<description^>^<![CDATA[ >> rfs%shortfilename1%_latlon.kml
echo ^<head^> >> rfs%shortfilename1%_latlon.kml
echo ^<style type="text/css"^> >> rfs%shortfilename1%_latlon.kml
echo #text {font-family:Verdana, Arial, Helvetica;} >> rfs%shortfilename1%_latlon.kml
echo ^</style^> >> rfs%shortfilename1%_latlon.kml
echo ^</head^> >> rfs%shortfilename1%_latlon.kml
echo ^<body^> >> rfs%shortfilename1%_latlon.kml
echo ^<div style="width:100%%;background-color:#406200;height:155px;margin-bottom:10px;"^> >> rfs%shortfilename1%_latlon.kml
echo ^<div style="float:left;"^> >> rfs%shortfilename1%_latlon.kml
echo ^<a href="http://www.itc.nl/Pub/WRS/WRS-GEONETCast" target="_blank"^>^<img src="http://www.utwente.nl/.system/dl/ic~AQGywQMApDbUAkg2CwB8X80CBwGBlgAAAAA6w_g" alt="RFS" title="RFS" style="float:left;margin:10px;" /^>^</a^> >> rfs%shortfilename1%_latlon.kml
echo ^</div^> >> rfs%shortfilename1%_latlon.kml
echo ^<div style="float:right;margin:5px;"^> >> rfs%shortfilename1%_latlon.kml
echo ^<span class="glyphicon glyphicon-globe" style="color:#fff"^>^</span^> ^<span style="color:#fff"^>FTP download address:^</span^> >> rfs%shortfilename1%_latlon.kml
echo ^<br /^>^<a href="ftp://ftp.itc.nl/pub/mpe/inpe_rfs" target="_blank" style="color:#fff"^>^<abbr title="ftp.itc.nl/pub/mpe/inpe_rfs"^>ftp://ftp.itc.nl/pub/mpe/infpe_rfs^</abbr^>^</a^> >> rfs%shortfilename1%_latlon.kml
echo ^<br /^>^<span class="glyphicon glyphicon-envelope" style="color:#fff"^>^</span^> ^<span style="color:#fff"^>E-mail Address:^</span^> >> rfs%shortfilename1%_latlon.kml


echo ^<br /^>^<a href="mailto:b.h.p.maathuis@utwente.nl" style="color:#fff"^>b.h.p.maathuis@utwente.nl^</a^> >> rfs%shortfilename1%_latlon.kml
echo ^</div^> >> rfs%shortfilename1%_latlon.kml
echo ^</div^> >> rfs%shortfilename1%_latlon.kml
echo ^<h2^>Accumulated convective rainfall estimates (RFS)^</h2^> >> rfs%shortfilename1%_latlon.kml
echo ^<strong^>Produced at 15 minutes temporal interval by INPE and near real time available through GEONETCast^</strong^> >> rfs%shortfilename1%_latlon.kml
echo ^<p^>This rainfall estimate comprises the accumulated convective rainfall estimates, based on GOES images, for the South America region. The estimation is based in the adjusted hydro-estimator methodology from South America, using INPE information about precipitated water, relative humidity and winds.^</p^> >> rfs%shortfilename1%_latlon.kml
echo ^<p^>Source http://navigator.eumetsat.int^</p^> >> rfs%shortfilename1%_latlon.kml

echo ^</div^> >> rfs%shortfilename1%_latlon.kml
echo ^<h2^>Data processing: ^</h2^> >> rfs%shortfilename1%_latlon.kml
echo ^<p^>At ITC these 15 minutes products are aggregated to obtain the 24 hour precipitation amount in mm/24hr(from 00:00 to 23:45 UTC). These files are compressed and subsequently transferred to a FTP site (ftp://ftp.itc.nl/pub/mpe/inpe_rfs/). The accumulated 24 hour precipitation map is retrieved, decompressed and transformed into a PNG format (with a transparent layer for the areas that have not received precipitation). A KML file is created and executed which invokes Google Earth to start and display the results. These applications assume that Google Earth is locally available.^</p^> >> rfs%shortfilename1%_latlon.kml
echo ^</div^> >> rfs%shortfilename1%_latlon.kml
echo ^</body^> >> rfs%shortfilename1%_latlon.kml
echo ^</html^> >> rfs%shortfilename1%_latlon.kml
echo ]]^>^</description^> >> rfs%shortfilename1%_latlon.kml
echo ^<gx:balloonVisibility^>1^</gx:balloonVisibility^> >> rfs%shortfilename1%_latlon.kml
echo ^<styleUrl^>#default^</styleUrl^> >> rfs%shortfilename1%_latlon.kml

echo ^</Placemark^> >> rfs%shortfilename1%_latlon.kml


echo ^</Document^> >> rfs%shortfilename1%_latlon.kml
echo ^</kml^> >> rfs%shortfilename1%_latlon.kml

rem start Google-Earth with the KML file
rfs%shortfilename1%_latlon.kml

rem cleanup unneeded temporary files
del rfs%shortfilename1%_latlon.mpl 
del rfs%shortfilename1%_latlon_alpha.mp* 
del rfs%shortfilename1%_latlon_blue.mp* 
del rfs%shortfilename1%_latlon_green.mp* 
del rfs%shortfilename1%_latlon_red.mp* 
del rfs%shortfilename1%_latlon.mp* 
del rfs%shortfilename1%_latlon.png.aux.xml 
del sumrfs_%shortfilename1%.zip
del rfs%shortfilename1%_latlon.kml
del rfs%shortfilename1%_latlon.png
del rfsgoogle.grf

:END
"%IlwDir%\ilwis.exe" -C closeall



