@echo off
echo Extract FEWS RFE climatology 
echo File contains on dekadal basis the data 
echo Utilizing the climatology method of the RFE (ARC) 
echo File name format clim.dekad.bin.011 up to clim.dekad.bin.123
echo Mean preciptiation per dekad
echo.
echo.

set InputDrive=%2
set InputDir=%3
set OutputDrive=%4
set OutputDir=%5
set gdalDir=%6
set IlwDir=%7
set UtilDir=%8

cd\
%OutputDrive%
cd %OutputDir%

echo your current working directory = %OutputDrive%\%OutputDir%
echo.
echo.

echo set OutputDrive=%4>inputparam.bat
echo set OutputDir=%5>>inputparam.bat
echo set IlwDir=%7>>inputparam.bat
echo set UtilDir=%8>>inputparam.bat


@echo on

"%UtilDir%\wget\wget.exe" ftp://ftp.cpc.ncep.noaa.gov/fews/AFR_CLIM/ARC2/CLIMATOLOGY_DATA/MEAN_DEKADAL_TOTALS/clim.dekad.bin.*


echo off
if not exist "%OutputDrive%\%OutputDir%\clim.dekad.bin.*"  goto MESSAGE
echo The files "dekad climatology-011 up to dekad climatology-123" have been retrieved and transferred to your current working directory
echo.
echo.

GOTO START

:MESSAGE
echo The input files have not been found in the archive.
echo Data is retrieved from ftp://ftp.cpc.ncep.noaa.gov/fews/AFR_CLIM/ARC2/CLIMATOLOGY_DATA/MEAN_DEKADAL_TOTALS/
echo Check also manually if the data exists on ftp archive (see link above)
echo Internet has a transient nature - addresses might not be valid or has changed after some time!


pause

GOTO END

:START


copy %IlwDir%\Extensions\ISOD-Toolbox\toolbox_batchroutines\fews_rfeclim_dekad_loop.bat

for %%j in (clim.dekad*) do cmd /c fews_rfeclim_dekad_loop.bat %%j


del clim.dekad.bin*
 
del fews_rfeclim_dekad_loop.bat
del inputparam.bat

:END
"%IlwDir%\ilwis.exe" -C closeall