echo off
echo Current Weather Conditions
echo Weather charts from NOAA NWS Gateway
echo From U.S. National Weather Service and other national and international agencies 
echo Import Terminal Areodrome Forecast station data (TAF)
echo Use appropriate ICAO airport code
echo Note the Code is case sensitive - code in Captials
echo System regional setting format is English (United States)
echo Short date format is M/d/yyyy
echo Short time format is h:mm tt
echo Uses internet explorer for display of html document
echo Iexplorer is started from default system directory
echo Imported file is not deleted from your working directory
echo You might need it for later reference
echo.
echo.


set longfilename=%1
set shortfilename1=%longfilename:~0,4%
set InputDrive=%2
set InputDir=%3
set OutputDrive=%4
set OutputDir=%5
set gdalDir=%6
set IlwDir=%7
set UtilDir=%8


cd\
%OutputDrive%
cd "%OutputDir%"
echo your current working directory = %OutputDrive%\%OutputDir%
echo.
echo.


"%UtilDir%\wget\wget.exe" http://weather.noaa.gov/weather/current/%shortfilename1%.html 

echo off
if not exist "%OutputDrive%\%OutputDir%\%shortfilename1%.html"  goto MESSAGE
echo The file(s) "%shortfilename1%.html" has been retrieved and transferred to your current working directory
echo.
echo.

GOTO START

:MESSAGE
echo The input file was not found in the archive.
echo Check your Date stamp settings
echo Your current ICAO stamp used is %shortfilename1%
echo Data is retrieved from http://weather.noaa.gov/weather/current/
echo Check also manually if the data exists on ftp archive (see link above)
echo Internet has a transient nature - addresses might not be valid or has changed after some time!


pause

GOTO END

:START

rem get local time from system clock time
rem for /F "usebackq tokens=1,2 delims==" %%i in (`wmic os get LocalDateTime /VALUE 2^>NUL`) do if '.%%i.'=='.LocalDateTime.' set ldt=%%j
rem set ldt=%ldt:~0,4%%ldt:~4,2%%ldt:~6,2%%ldt:~8,2%%ldt:~10,2%
rem echo Routine extracted TAF report at local datetime [yyyymmddhhmm]: %ldt%


rem Creates an environment variable datetime as YYYYMMDDHHMM

for /f "tokens=2 delims==" %%I in ('wmic os get localdatetime /format:list') do set datetime=%%I
set rdate=%datetime:~0,4%%datetime:~4,2%%datetime:~6,2%%datetime:~8,4%

rem pause
echo Routine extracted TAF report at local datetime [yyyymmddhhmm]: %rdate%

rename %shortfilename1%.html %shortfilename1%_%rdate%.html

"%OutputDrive%\%OutputDir%\%shortfilename1%_%rdate%.html"

:END
"%IlwDir%\ilwis.exe" -C closeall


