@echo off
echo Extract TRMM 3b42 3-hour and day esitmates
echo Archive from 1998 up to 3 months before present
echo Precipitation for 3 hour instance in mm/hr
echo Precipitation for day in mm/day
echo file name format 3B42.19980101.03.7.HDF
echo Data retrieved from ftp://disc2.nascom.nasa.gov/ftp/data/s4pa/TRMM_L3/TRMM_3B42/
echo Data resides under year and julian day sub-directories
echo 8 files are downloaded and contain 3 hr time step
echo Currently algorithm version 7 is supported
echo.
echo.
 
set longfilename=%1
set shortfilename1=%longfilename:~0,8%
set InputDrive=%2
set InputDir=%3
set OutputDrive=%4
set OutputDir=%5
set gdalDir=%6
set IlwDir=%7
set UtilDir=%8


cd\
%OutputDrive%
cd %OutputDir%

echo your current working directory = %OutputDrive%\%OutputDir%
echo.
echo.
echo The 8 "3B42.%shortfilename1%" files needed are being downloaded to your output directory
echo.

rem use is made of DownloadTRMM.jar 

java -jar "%UtilDir%\DownloadTRMM.jar" %shortfilename1% %OutputDrive%\%OutputDir%


echo off
if not exist %OutputDrive%\%OutputDir%\"3B42.%shortfilename1%.??.7.HDF"  goto MESSAGE
echo All the 8 "3B42.%shortfilename1%.??.7.HDF" files have been retrieved to your current working directory
echo .
echo .


GOTO START

:MESSAGE
echo The input files are not found.
echo Check your directory and date stamp settings
echo Your current date stamp used is %shortfilename1%
echo Check also if the data exists on your input directory - archive 


pause

GOTO END

:START

echo set OutputDrive=%4>inputparam.bat
echo set OutputDir=%5>>inputparam.bat
echo set GdalDir=%6>>inputparam.bat
echo set IlwDir=%7>>inputparam.bat
echo set UtilDir=%8>>inputparam.bat


dir 3B42.%shortfilename1%.??.7.HDF >ch.txt
findstr /R /N "^" ch.txt | find /C ":" >ch1.txt

setLocal EnableDelayedExpansion
for /f "tokens=* delims= " %%a in (ch1.txt) do (
if !check_var!'==' set check_var=%%a
)

rem the file ch.txt consits of 8 lines with filenames and 7 other lines

if %check_var% NEQ 15 GOTO MESSAGE1
if %check_var% EQU 15 GOTO START1


:MESSAGE1
echo.
echo.
echo Not all required input files could be retrieved
echo Ensure that 8 "3B42.%shortfilename1%.??.7.HDF" are available
echo Check your working directory for the missing files
echo.
echo.

GOTO END

:START1



copy "%IlwDir%\Extensions\ISOD-Toolbox\toolbox_batchroutines\trmm_3B42_025d_day_loop.bat"

for %%j in (3B42.%shortfilename1%*) do cmd /c trmm_3B42_025d_day_loop.bat %%j


copy "%IlwDir%\Extensions\ISOD-Toolbox\util\mpl_substitutename.bat"
copy "%IlwDir%\Extensions\ISOD-Toolbox\util\trmm_3B42_org.mpl"

cmd /c mpl_substitutename.bat ____ _%shortfilename1%_ trmm_3B42_org.mpl > trmm_3B42_%shortfilename1%.mpl

rem further processing required

"%IlwDir%\ilwis.exe" -C %OutputDrive%\%OutputDir%\trmm_3B42_%shortfilename1%_s.mpr:=MapMaplistStatistics(%OutputDrive%\%OutputDir%\trmm_3B42_%shortfilename1%.mpl,Sum)
"%IlwDir%\ilwis.exe" -C %OutputDrive%\%OutputDir%\trmm_3B42_%shortfilename1%_day.mpr:=%OutputDrive%\%OutputDir%\trmm_3B42_%shortfilename1%_s*3

rem delete remaining obsolete objects

del %OutputDrive%\%OutputDir%\ch1.txt
del %OutputDrive%\%OutputDir%\ch.txt
del %OutputDrive%\%OutputDir%\inputparam.bat
del %OutputDrive%\%OutputDir%\trmm_3B42_025d_day_loop.bat
del %OutputDrive%\%OutputDir%\3B42.%shortfilename1%*.HDF
del %OutputDrive%\%OutputDir%\trmm_3B42_%shortfilename1%_s.mp*
del %OutputDrive%\%OutputDir%\trmm_3B42_org.mpl
del %OutputDrive%\%OutputDir%\mpl_substitutename.bat



:END
"%IlwDir%\ilwis.exe" -C closeall